export declare enum PromiseState {
    IDLE = "idle",
    PENDING = "pending",
    REJECTED = "rejected",
    FULFILLED = "fulfilled"
}
export declare type PromiseData<ResultType, ErrorType> = {
    state: PromiseState.IDLE;
    idle: true;
    pending: false;
    rejected: false;
    fulfilled: false;
    result: undefined;
    error: undefined;
} | {
    state: PromiseState.PENDING;
    idle: false;
    pending: true;
    rejected: false;
    fulfilled: false;
    result: undefined;
    error: undefined;
} | {
    state: PromiseState.REJECTED;
    idle: false;
    pending: false;
    rejected: true;
    fulfilled: false;
    result: undefined;
    error: ErrorType;
} | {
    state: PromiseState.FULFILLED;
    idle: false;
    pending: false;
    rejected: false;
    fulfilled: true;
    result: ResultType;
    error: undefined;
};
export default function usePromised<Result = unknown, Error = unknown>(): [PromiseData<Result, Error>, (promise: Promise<Result> | undefined) => void];
