import { useState, useEffect } from 'react';

var PromiseState;

(function (PromiseState) {
  PromiseState["IDLE"] = "idle";
  PromiseState["PENDING"] = "pending";
  PromiseState["REJECTED"] = "rejected";
  PromiseState["FULFILLED"] = "fulfilled";
})(PromiseState || (PromiseState = {}));

function usePromised() {
  var _useState = useState(),
      promise = _useState[0],
      setPromise = _useState[1];

  var _useState2 = useState({
    state: PromiseState.IDLE,
    idle: true,
    pending: false,
    rejected: false,
    fulfilled: false,
    error: undefined,
    result: undefined
  }),
      data = _useState2[0],
      setData = _useState2[1];

  useEffect(function () {
    var isCanceled = false;

    if (promise) {
      setData({
        state: PromiseState.PENDING,
        idle: false,
        pending: true,
        rejected: false,
        fulfilled: false,
        error: undefined,
        result: undefined
      });
      promise.then(function (receivedResult) {
        if (isCanceled) return;
        setData({
          state: PromiseState.FULFILLED,
          idle: false,
          pending: false,
          rejected: false,
          fulfilled: true,
          result: receivedResult,
          error: undefined
        });
      })["catch"](function (receivedError) {
        if (isCanceled) return;
        setData({
          state: PromiseState.REJECTED,
          idle: false,
          pending: false,
          rejected: true,
          fulfilled: false,
          error: receivedError,
          result: undefined
        });
      });
    } else {
      setData({
        state: PromiseState.IDLE,
        idle: true,
        pending: false,
        rejected: false,
        fulfilled: false,
        result: undefined,
        error: undefined
      });
    }

    return function () {
      isCanceled = true;
    };
  }, [promise]);
  return [data, setPromise];
}

export default usePromised;
export { PromiseState };
//# sourceMappingURL=use-promised.esm.js.map
